/**
 * Autogenerated by Avro
 *
 * DO NOT EDIT DIRECTLY
 */
package io.asouquieres.avromodel;

import org.apache.avro.generic.GenericArray;
import org.apache.avro.specific.SpecificData;
import org.apache.avro.util.Utf8;
import org.apache.avro.message.BinaryMessageEncoder;
import org.apache.avro.message.BinaryMessageDecoder;
import org.apache.avro.message.SchemaStore;

/** Demo avro model with near all type of fields available in avro */
@org.apache.avro.specific.AvroGenerated
public class DemoAvro extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  private static final long serialVersionUID = 6633390242277410645L;
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"DemoAvro\",\"namespace\":\"io.asouquieres.avromodel\",\"doc\":\"Demo avro model with near all type of fields available in avro\",\"fields\":[{\"name\":\"stringField\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"optionalStringField\",\"type\":[\"null\",{\"type\":\"string\",\"avro.java.string\":\"String\"}],\"default\":null},{\"name\":\"arrayOfObject\",\"type\":{\"type\":\"array\",\"items\":{\"type\":\"record\",\"name\":\"ChildAvro\",\"fields\":[{\"name\":\"name\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}}]}}},{\"name\":\"mapOfStrings\",\"type\":{\"type\":\"map\",\"values\":{\"type\":\"string\",\"avro.java.string\":\"String\"},\"avro.java.string\":\"String\"}},{\"name\":\"mapOfReusedObjects\",\"type\":{\"type\":\"map\",\"values\":\"ChildAvro\",\"avro.java.string\":\"String\"}},{\"name\":\"booleanField\",\"type\":\"boolean\"},{\"name\":\"intField\",\"type\":\"int\"},{\"name\":\"longField\",\"type\":\"long\"},{\"name\":\"floatField\",\"type\":\"float\"},{\"name\":\"doubleField\",\"type\":\"double\"},{\"name\":\"bytesField\",\"type\":\"bytes\"},{\"name\":\"decimalField\",\"type\":{\"type\":\"bytes\",\"logicalType\":\"decimal\",\"precision\":4,\"scale\":2}},{\"name\":\"timestampLogicalField\",\"type\":{\"type\":\"long\",\"logicalType\":\"timestamp-millis\"}}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }

  private static SpecificData MODEL$ = new SpecificData();
static {
    MODEL$.addLogicalTypeConversion(new org.apache.avro.data.TimeConversions.TimestampMillisConversion());
    MODEL$.addLogicalTypeConversion(new org.apache.avro.Conversions.DecimalConversion());
  }

  private static final BinaryMessageEncoder<DemoAvro> ENCODER =
      new BinaryMessageEncoder<DemoAvro>(MODEL$, SCHEMA$);

  private static final BinaryMessageDecoder<DemoAvro> DECODER =
      new BinaryMessageDecoder<DemoAvro>(MODEL$, SCHEMA$);

  /**
   * Return the BinaryMessageEncoder instance used by this class.
   * @return the message encoder used by this class
   */
  public static BinaryMessageEncoder<DemoAvro> getEncoder() {
    return ENCODER;
  }

  /**
   * Return the BinaryMessageDecoder instance used by this class.
   * @return the message decoder used by this class
   */
  public static BinaryMessageDecoder<DemoAvro> getDecoder() {
    return DECODER;
  }

  /**
   * Create a new BinaryMessageDecoder instance for this class that uses the specified {@link SchemaStore}.
   * @param resolver a {@link SchemaStore} used to find schemas by fingerprint
   * @return a BinaryMessageDecoder instance for this class backed by the given SchemaStore
   */
  public static BinaryMessageDecoder<DemoAvro> createDecoder(SchemaStore resolver) {
    return new BinaryMessageDecoder<DemoAvro>(MODEL$, SCHEMA$, resolver);
  }

  /**
   * Serializes this DemoAvro to a ByteBuffer.
   * @return a buffer holding the serialized data for this instance
   * @throws java.io.IOException if this instance could not be serialized
   */
  public java.nio.ByteBuffer toByteBuffer() throws java.io.IOException {
    return ENCODER.encode(this);
  }

  /**
   * Deserializes a DemoAvro from a ByteBuffer.
   * @param b a byte buffer holding serialized data for an instance of this class
   * @return a DemoAvro instance decoded from the given buffer
   * @throws java.io.IOException if the given bytes could not be deserialized into an instance of this class
   */
  public static DemoAvro fromByteBuffer(
      java.nio.ByteBuffer b) throws java.io.IOException {
    return DECODER.decode(b);
  }

   private java.lang.String stringField;
   private java.lang.String optionalStringField;
   private java.util.List<io.asouquieres.avromodel.ChildAvro> arrayOfObject;
   private java.util.Map<java.lang.String,java.lang.String> mapOfStrings;
   private java.util.Map<java.lang.String,io.asouquieres.avromodel.ChildAvro> mapOfReusedObjects;
   private boolean booleanField;
   private int intField;
   private long longField;
   private float floatField;
   private double doubleField;
   private java.nio.ByteBuffer bytesField;
   private java.math.BigDecimal decimalField;
   private java.time.Instant timestampLogicalField;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use <code>newBuilder()</code>.
   */
  public DemoAvro() {}

  /**
   * All-args constructor.
   * @param stringField The new value for stringField
   * @param optionalStringField The new value for optionalStringField
   * @param arrayOfObject The new value for arrayOfObject
   * @param mapOfStrings The new value for mapOfStrings
   * @param mapOfReusedObjects The new value for mapOfReusedObjects
   * @param booleanField The new value for booleanField
   * @param intField The new value for intField
   * @param longField The new value for longField
   * @param floatField The new value for floatField
   * @param doubleField The new value for doubleField
   * @param bytesField The new value for bytesField
   * @param decimalField The new value for decimalField
   * @param timestampLogicalField The new value for timestampLogicalField
   */
  public DemoAvro(java.lang.String stringField, java.lang.String optionalStringField, java.util.List<io.asouquieres.avromodel.ChildAvro> arrayOfObject, java.util.Map<java.lang.String,java.lang.String> mapOfStrings, java.util.Map<java.lang.String,io.asouquieres.avromodel.ChildAvro> mapOfReusedObjects, java.lang.Boolean booleanField, java.lang.Integer intField, java.lang.Long longField, java.lang.Float floatField, java.lang.Double doubleField, java.nio.ByteBuffer bytesField, java.math.BigDecimal decimalField, java.time.Instant timestampLogicalField) {
    this.stringField = stringField;
    this.optionalStringField = optionalStringField;
    this.arrayOfObject = arrayOfObject;
    this.mapOfStrings = mapOfStrings;
    this.mapOfReusedObjects = mapOfReusedObjects;
    this.booleanField = booleanField;
    this.intField = intField;
    this.longField = longField;
    this.floatField = floatField;
    this.doubleField = doubleField;
    this.bytesField = bytesField;
    this.decimalField = decimalField;
    this.timestampLogicalField = timestampLogicalField.truncatedTo(java.time.temporal.ChronoUnit.MILLIS);
  }

  public org.apache.avro.specific.SpecificData getSpecificData() { return MODEL$; }
  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call.
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return stringField;
    case 1: return optionalStringField;
    case 2: return arrayOfObject;
    case 3: return mapOfStrings;
    case 4: return mapOfReusedObjects;
    case 5: return booleanField;
    case 6: return intField;
    case 7: return longField;
    case 8: return floatField;
    case 9: return doubleField;
    case 10: return bytesField;
    case 11: return decimalField;
    case 12: return timestampLogicalField;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  private static final org.apache.avro.Conversion<?>[] conversions =
      new org.apache.avro.Conversion<?>[] {
      null,
      null,
      null,
      null,
      null,
      null,
      null,
      null,
      null,
      null,
      null,
      new org.apache.avro.Conversions.DecimalConversion(),
      new org.apache.avro.data.TimeConversions.TimestampMillisConversion(),
      null
  };

  @Override
  public org.apache.avro.Conversion<?> getConversion(int field) {
    return conversions[field];
  }

  // Used by DatumReader.  Applications should not call.
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: stringField = value$ != null ? value$.toString() : null; break;
    case 1: optionalStringField = value$ != null ? value$.toString() : null; break;
    case 2: arrayOfObject = (java.util.List<io.asouquieres.avromodel.ChildAvro>)value$; break;
    case 3: mapOfStrings = (java.util.Map<java.lang.String,java.lang.String>)value$; break;
    case 4: mapOfReusedObjects = (java.util.Map<java.lang.String,io.asouquieres.avromodel.ChildAvro>)value$; break;
    case 5: booleanField = (java.lang.Boolean)value$; break;
    case 6: intField = (java.lang.Integer)value$; break;
    case 7: longField = (java.lang.Long)value$; break;
    case 8: floatField = (java.lang.Float)value$; break;
    case 9: doubleField = (java.lang.Double)value$; break;
    case 10: bytesField = (java.nio.ByteBuffer)value$; break;
    case 11: decimalField = (java.math.BigDecimal)value$; break;
    case 12: timestampLogicalField = (java.time.Instant)value$; break;
    default: throw new IndexOutOfBoundsException("Invalid index: " + field$);
    }
  }

  /**
   * Gets the value of the 'stringField' field.
   * @return The value of the 'stringField' field.
   */
  public java.lang.String getStringField() {
    return stringField;
  }


  /**
   * Sets the value of the 'stringField' field.
   * @param value the value to set.
   */
  public void setStringField(java.lang.String value) {
    this.stringField = value;
  }

  /**
   * Gets the value of the 'optionalStringField' field.
   * @return The value of the 'optionalStringField' field.
   */
  public java.lang.String getOptionalStringField() {
    return optionalStringField;
  }


  /**
   * Sets the value of the 'optionalStringField' field.
   * @param value the value to set.
   */
  public void setOptionalStringField(java.lang.String value) {
    this.optionalStringField = value;
  }

  /**
   * Gets the value of the 'arrayOfObject' field.
   * @return The value of the 'arrayOfObject' field.
   */
  public java.util.List<io.asouquieres.avromodel.ChildAvro> getArrayOfObject() {
    return arrayOfObject;
  }


  /**
   * Sets the value of the 'arrayOfObject' field.
   * @param value the value to set.
   */
  public void setArrayOfObject(java.util.List<io.asouquieres.avromodel.ChildAvro> value) {
    this.arrayOfObject = value;
  }

  /**
   * Gets the value of the 'mapOfStrings' field.
   * @return The value of the 'mapOfStrings' field.
   */
  public java.util.Map<java.lang.String,java.lang.String> getMapOfStrings() {
    return mapOfStrings;
  }


  /**
   * Sets the value of the 'mapOfStrings' field.
   * @param value the value to set.
   */
  public void setMapOfStrings(java.util.Map<java.lang.String,java.lang.String> value) {
    this.mapOfStrings = value;
  }

  /**
   * Gets the value of the 'mapOfReusedObjects' field.
   * @return The value of the 'mapOfReusedObjects' field.
   */
  public java.util.Map<java.lang.String,io.asouquieres.avromodel.ChildAvro> getMapOfReusedObjects() {
    return mapOfReusedObjects;
  }


  /**
   * Sets the value of the 'mapOfReusedObjects' field.
   * @param value the value to set.
   */
  public void setMapOfReusedObjects(java.util.Map<java.lang.String,io.asouquieres.avromodel.ChildAvro> value) {
    this.mapOfReusedObjects = value;
  }

  /**
   * Gets the value of the 'booleanField' field.
   * @return The value of the 'booleanField' field.
   */
  public boolean getBooleanField() {
    return booleanField;
  }


  /**
   * Sets the value of the 'booleanField' field.
   * @param value the value to set.
   */
  public void setBooleanField(boolean value) {
    this.booleanField = value;
  }

  /**
   * Gets the value of the 'intField' field.
   * @return The value of the 'intField' field.
   */
  public int getIntField() {
    return intField;
  }


  /**
   * Sets the value of the 'intField' field.
   * @param value the value to set.
   */
  public void setIntField(int value) {
    this.intField = value;
  }

  /**
   * Gets the value of the 'longField' field.
   * @return The value of the 'longField' field.
   */
  public long getLongField() {
    return longField;
  }


  /**
   * Sets the value of the 'longField' field.
   * @param value the value to set.
   */
  public void setLongField(long value) {
    this.longField = value;
  }

  /**
   * Gets the value of the 'floatField' field.
   * @return The value of the 'floatField' field.
   */
  public float getFloatField() {
    return floatField;
  }


  /**
   * Sets the value of the 'floatField' field.
   * @param value the value to set.
   */
  public void setFloatField(float value) {
    this.floatField = value;
  }

  /**
   * Gets the value of the 'doubleField' field.
   * @return The value of the 'doubleField' field.
   */
  public double getDoubleField() {
    return doubleField;
  }


  /**
   * Sets the value of the 'doubleField' field.
   * @param value the value to set.
   */
  public void setDoubleField(double value) {
    this.doubleField = value;
  }

  /**
   * Gets the value of the 'bytesField' field.
   * @return The value of the 'bytesField' field.
   */
  public java.nio.ByteBuffer getBytesField() {
    return bytesField;
  }


  /**
   * Sets the value of the 'bytesField' field.
   * @param value the value to set.
   */
  public void setBytesField(java.nio.ByteBuffer value) {
    this.bytesField = value;
  }

  /**
   * Gets the value of the 'decimalField' field.
   * @return The value of the 'decimalField' field.
   */
  public java.math.BigDecimal getDecimalField() {
    return decimalField;
  }


  /**
   * Sets the value of the 'decimalField' field.
   * @param value the value to set.
   */
  public void setDecimalField(java.math.BigDecimal value) {
    this.decimalField = value;
  }

  /**
   * Gets the value of the 'timestampLogicalField' field.
   * @return The value of the 'timestampLogicalField' field.
   */
  public java.time.Instant getTimestampLogicalField() {
    return timestampLogicalField;
  }


  /**
   * Sets the value of the 'timestampLogicalField' field.
   * @param value the value to set.
   */
  public void setTimestampLogicalField(java.time.Instant value) {
    this.timestampLogicalField = value.truncatedTo(java.time.temporal.ChronoUnit.MILLIS);
  }

  /**
   * Creates a new DemoAvro RecordBuilder.
   * @return A new DemoAvro RecordBuilder
   */
  public static io.asouquieres.avromodel.DemoAvro.Builder newBuilder() {
    return new io.asouquieres.avromodel.DemoAvro.Builder();
  }

  /**
   * Creates a new DemoAvro RecordBuilder by copying an existing Builder.
   * @param other The existing builder to copy.
   * @return A new DemoAvro RecordBuilder
   */
  public static io.asouquieres.avromodel.DemoAvro.Builder newBuilder(io.asouquieres.avromodel.DemoAvro.Builder other) {
    if (other == null) {
      return new io.asouquieres.avromodel.DemoAvro.Builder();
    } else {
      return new io.asouquieres.avromodel.DemoAvro.Builder(other);
    }
  }

  /**
   * Creates a new DemoAvro RecordBuilder by copying an existing DemoAvro instance.
   * @param other The existing instance to copy.
   * @return A new DemoAvro RecordBuilder
   */
  public static io.asouquieres.avromodel.DemoAvro.Builder newBuilder(io.asouquieres.avromodel.DemoAvro other) {
    if (other == null) {
      return new io.asouquieres.avromodel.DemoAvro.Builder();
    } else {
      return new io.asouquieres.avromodel.DemoAvro.Builder(other);
    }
  }

  /**
   * RecordBuilder for DemoAvro instances.
   */
  @org.apache.avro.specific.AvroGenerated
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<DemoAvro>
    implements org.apache.avro.data.RecordBuilder<DemoAvro> {

    private java.lang.String stringField;
    private java.lang.String optionalStringField;
    private java.util.List<io.asouquieres.avromodel.ChildAvro> arrayOfObject;
    private java.util.Map<java.lang.String,java.lang.String> mapOfStrings;
    private java.util.Map<java.lang.String,io.asouquieres.avromodel.ChildAvro> mapOfReusedObjects;
    private boolean booleanField;
    private int intField;
    private long longField;
    private float floatField;
    private double doubleField;
    private java.nio.ByteBuffer bytesField;
    private java.math.BigDecimal decimalField;
    private java.time.Instant timestampLogicalField;

    /** Creates a new Builder */
    private Builder() {
      super(SCHEMA$);
    }

    /**
     * Creates a Builder by copying an existing Builder.
     * @param other The existing Builder to copy.
     */
    private Builder(io.asouquieres.avromodel.DemoAvro.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.stringField)) {
        this.stringField = data().deepCopy(fields()[0].schema(), other.stringField);
        fieldSetFlags()[0] = other.fieldSetFlags()[0];
      }
      if (isValidValue(fields()[1], other.optionalStringField)) {
        this.optionalStringField = data().deepCopy(fields()[1].schema(), other.optionalStringField);
        fieldSetFlags()[1] = other.fieldSetFlags()[1];
      }
      if (isValidValue(fields()[2], other.arrayOfObject)) {
        this.arrayOfObject = data().deepCopy(fields()[2].schema(), other.arrayOfObject);
        fieldSetFlags()[2] = other.fieldSetFlags()[2];
      }
      if (isValidValue(fields()[3], other.mapOfStrings)) {
        this.mapOfStrings = data().deepCopy(fields()[3].schema(), other.mapOfStrings);
        fieldSetFlags()[3] = other.fieldSetFlags()[3];
      }
      if (isValidValue(fields()[4], other.mapOfReusedObjects)) {
        this.mapOfReusedObjects = data().deepCopy(fields()[4].schema(), other.mapOfReusedObjects);
        fieldSetFlags()[4] = other.fieldSetFlags()[4];
      }
      if (isValidValue(fields()[5], other.booleanField)) {
        this.booleanField = data().deepCopy(fields()[5].schema(), other.booleanField);
        fieldSetFlags()[5] = other.fieldSetFlags()[5];
      }
      if (isValidValue(fields()[6], other.intField)) {
        this.intField = data().deepCopy(fields()[6].schema(), other.intField);
        fieldSetFlags()[6] = other.fieldSetFlags()[6];
      }
      if (isValidValue(fields()[7], other.longField)) {
        this.longField = data().deepCopy(fields()[7].schema(), other.longField);
        fieldSetFlags()[7] = other.fieldSetFlags()[7];
      }
      if (isValidValue(fields()[8], other.floatField)) {
        this.floatField = data().deepCopy(fields()[8].schema(), other.floatField);
        fieldSetFlags()[8] = other.fieldSetFlags()[8];
      }
      if (isValidValue(fields()[9], other.doubleField)) {
        this.doubleField = data().deepCopy(fields()[9].schema(), other.doubleField);
        fieldSetFlags()[9] = other.fieldSetFlags()[9];
      }
      if (isValidValue(fields()[10], other.bytesField)) {
        this.bytesField = data().deepCopy(fields()[10].schema(), other.bytesField);
        fieldSetFlags()[10] = other.fieldSetFlags()[10];
      }
      if (isValidValue(fields()[11], other.decimalField)) {
        this.decimalField = data().deepCopy(fields()[11].schema(), other.decimalField);
        fieldSetFlags()[11] = other.fieldSetFlags()[11];
      }
      if (isValidValue(fields()[12], other.timestampLogicalField)) {
        this.timestampLogicalField = data().deepCopy(fields()[12].schema(), other.timestampLogicalField);
        fieldSetFlags()[12] = other.fieldSetFlags()[12];
      }
    }

    /**
     * Creates a Builder by copying an existing DemoAvro instance
     * @param other The existing instance to copy.
     */
    private Builder(io.asouquieres.avromodel.DemoAvro other) {
      super(SCHEMA$);
      if (isValidValue(fields()[0], other.stringField)) {
        this.stringField = data().deepCopy(fields()[0].schema(), other.stringField);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.optionalStringField)) {
        this.optionalStringField = data().deepCopy(fields()[1].schema(), other.optionalStringField);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.arrayOfObject)) {
        this.arrayOfObject = data().deepCopy(fields()[2].schema(), other.arrayOfObject);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.mapOfStrings)) {
        this.mapOfStrings = data().deepCopy(fields()[3].schema(), other.mapOfStrings);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.mapOfReusedObjects)) {
        this.mapOfReusedObjects = data().deepCopy(fields()[4].schema(), other.mapOfReusedObjects);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.booleanField)) {
        this.booleanField = data().deepCopy(fields()[5].schema(), other.booleanField);
        fieldSetFlags()[5] = true;
      }
      if (isValidValue(fields()[6], other.intField)) {
        this.intField = data().deepCopy(fields()[6].schema(), other.intField);
        fieldSetFlags()[6] = true;
      }
      if (isValidValue(fields()[7], other.longField)) {
        this.longField = data().deepCopy(fields()[7].schema(), other.longField);
        fieldSetFlags()[7] = true;
      }
      if (isValidValue(fields()[8], other.floatField)) {
        this.floatField = data().deepCopy(fields()[8].schema(), other.floatField);
        fieldSetFlags()[8] = true;
      }
      if (isValidValue(fields()[9], other.doubleField)) {
        this.doubleField = data().deepCopy(fields()[9].schema(), other.doubleField);
        fieldSetFlags()[9] = true;
      }
      if (isValidValue(fields()[10], other.bytesField)) {
        this.bytesField = data().deepCopy(fields()[10].schema(), other.bytesField);
        fieldSetFlags()[10] = true;
      }
      if (isValidValue(fields()[11], other.decimalField)) {
        this.decimalField = data().deepCopy(fields()[11].schema(), other.decimalField);
        fieldSetFlags()[11] = true;
      }
      if (isValidValue(fields()[12], other.timestampLogicalField)) {
        this.timestampLogicalField = data().deepCopy(fields()[12].schema(), other.timestampLogicalField);
        fieldSetFlags()[12] = true;
      }
    }

    /**
      * Gets the value of the 'stringField' field.
      * @return The value.
      */
    public java.lang.String getStringField() {
      return stringField;
    }


    /**
      * Sets the value of the 'stringField' field.
      * @param value The value of 'stringField'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setStringField(java.lang.String value) {
      validate(fields()[0], value);
      this.stringField = value;
      fieldSetFlags()[0] = true;
      return this;
    }

    /**
      * Checks whether the 'stringField' field has been set.
      * @return True if the 'stringField' field has been set, false otherwise.
      */
    public boolean hasStringField() {
      return fieldSetFlags()[0];
    }


    /**
      * Clears the value of the 'stringField' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearStringField() {
      stringField = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    /**
      * Gets the value of the 'optionalStringField' field.
      * @return The value.
      */
    public java.lang.String getOptionalStringField() {
      return optionalStringField;
    }


    /**
      * Sets the value of the 'optionalStringField' field.
      * @param value The value of 'optionalStringField'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setOptionalStringField(java.lang.String value) {
      validate(fields()[1], value);
      this.optionalStringField = value;
      fieldSetFlags()[1] = true;
      return this;
    }

    /**
      * Checks whether the 'optionalStringField' field has been set.
      * @return True if the 'optionalStringField' field has been set, false otherwise.
      */
    public boolean hasOptionalStringField() {
      return fieldSetFlags()[1];
    }


    /**
      * Clears the value of the 'optionalStringField' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearOptionalStringField() {
      optionalStringField = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /**
      * Gets the value of the 'arrayOfObject' field.
      * @return The value.
      */
    public java.util.List<io.asouquieres.avromodel.ChildAvro> getArrayOfObject() {
      return arrayOfObject;
    }


    /**
      * Sets the value of the 'arrayOfObject' field.
      * @param value The value of 'arrayOfObject'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setArrayOfObject(java.util.List<io.asouquieres.avromodel.ChildAvro> value) {
      validate(fields()[2], value);
      this.arrayOfObject = value;
      fieldSetFlags()[2] = true;
      return this;
    }

    /**
      * Checks whether the 'arrayOfObject' field has been set.
      * @return True if the 'arrayOfObject' field has been set, false otherwise.
      */
    public boolean hasArrayOfObject() {
      return fieldSetFlags()[2];
    }


    /**
      * Clears the value of the 'arrayOfObject' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearArrayOfObject() {
      arrayOfObject = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /**
      * Gets the value of the 'mapOfStrings' field.
      * @return The value.
      */
    public java.util.Map<java.lang.String,java.lang.String> getMapOfStrings() {
      return mapOfStrings;
    }


    /**
      * Sets the value of the 'mapOfStrings' field.
      * @param value The value of 'mapOfStrings'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setMapOfStrings(java.util.Map<java.lang.String,java.lang.String> value) {
      validate(fields()[3], value);
      this.mapOfStrings = value;
      fieldSetFlags()[3] = true;
      return this;
    }

    /**
      * Checks whether the 'mapOfStrings' field has been set.
      * @return True if the 'mapOfStrings' field has been set, false otherwise.
      */
    public boolean hasMapOfStrings() {
      return fieldSetFlags()[3];
    }


    /**
      * Clears the value of the 'mapOfStrings' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearMapOfStrings() {
      mapOfStrings = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    /**
      * Gets the value of the 'mapOfReusedObjects' field.
      * @return The value.
      */
    public java.util.Map<java.lang.String,io.asouquieres.avromodel.ChildAvro> getMapOfReusedObjects() {
      return mapOfReusedObjects;
    }


    /**
      * Sets the value of the 'mapOfReusedObjects' field.
      * @param value The value of 'mapOfReusedObjects'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setMapOfReusedObjects(java.util.Map<java.lang.String,io.asouquieres.avromodel.ChildAvro> value) {
      validate(fields()[4], value);
      this.mapOfReusedObjects = value;
      fieldSetFlags()[4] = true;
      return this;
    }

    /**
      * Checks whether the 'mapOfReusedObjects' field has been set.
      * @return True if the 'mapOfReusedObjects' field has been set, false otherwise.
      */
    public boolean hasMapOfReusedObjects() {
      return fieldSetFlags()[4];
    }


    /**
      * Clears the value of the 'mapOfReusedObjects' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearMapOfReusedObjects() {
      mapOfReusedObjects = null;
      fieldSetFlags()[4] = false;
      return this;
    }

    /**
      * Gets the value of the 'booleanField' field.
      * @return The value.
      */
    public boolean getBooleanField() {
      return booleanField;
    }


    /**
      * Sets the value of the 'booleanField' field.
      * @param value The value of 'booleanField'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setBooleanField(boolean value) {
      validate(fields()[5], value);
      this.booleanField = value;
      fieldSetFlags()[5] = true;
      return this;
    }

    /**
      * Checks whether the 'booleanField' field has been set.
      * @return True if the 'booleanField' field has been set, false otherwise.
      */
    public boolean hasBooleanField() {
      return fieldSetFlags()[5];
    }


    /**
      * Clears the value of the 'booleanField' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearBooleanField() {
      fieldSetFlags()[5] = false;
      return this;
    }

    /**
      * Gets the value of the 'intField' field.
      * @return The value.
      */
    public int getIntField() {
      return intField;
    }


    /**
      * Sets the value of the 'intField' field.
      * @param value The value of 'intField'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setIntField(int value) {
      validate(fields()[6], value);
      this.intField = value;
      fieldSetFlags()[6] = true;
      return this;
    }

    /**
      * Checks whether the 'intField' field has been set.
      * @return True if the 'intField' field has been set, false otherwise.
      */
    public boolean hasIntField() {
      return fieldSetFlags()[6];
    }


    /**
      * Clears the value of the 'intField' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearIntField() {
      fieldSetFlags()[6] = false;
      return this;
    }

    /**
      * Gets the value of the 'longField' field.
      * @return The value.
      */
    public long getLongField() {
      return longField;
    }


    /**
      * Sets the value of the 'longField' field.
      * @param value The value of 'longField'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setLongField(long value) {
      validate(fields()[7], value);
      this.longField = value;
      fieldSetFlags()[7] = true;
      return this;
    }

    /**
      * Checks whether the 'longField' field has been set.
      * @return True if the 'longField' field has been set, false otherwise.
      */
    public boolean hasLongField() {
      return fieldSetFlags()[7];
    }


    /**
      * Clears the value of the 'longField' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearLongField() {
      fieldSetFlags()[7] = false;
      return this;
    }

    /**
      * Gets the value of the 'floatField' field.
      * @return The value.
      */
    public float getFloatField() {
      return floatField;
    }


    /**
      * Sets the value of the 'floatField' field.
      * @param value The value of 'floatField'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setFloatField(float value) {
      validate(fields()[8], value);
      this.floatField = value;
      fieldSetFlags()[8] = true;
      return this;
    }

    /**
      * Checks whether the 'floatField' field has been set.
      * @return True if the 'floatField' field has been set, false otherwise.
      */
    public boolean hasFloatField() {
      return fieldSetFlags()[8];
    }


    /**
      * Clears the value of the 'floatField' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearFloatField() {
      fieldSetFlags()[8] = false;
      return this;
    }

    /**
      * Gets the value of the 'doubleField' field.
      * @return The value.
      */
    public double getDoubleField() {
      return doubleField;
    }


    /**
      * Sets the value of the 'doubleField' field.
      * @param value The value of 'doubleField'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setDoubleField(double value) {
      validate(fields()[9], value);
      this.doubleField = value;
      fieldSetFlags()[9] = true;
      return this;
    }

    /**
      * Checks whether the 'doubleField' field has been set.
      * @return True if the 'doubleField' field has been set, false otherwise.
      */
    public boolean hasDoubleField() {
      return fieldSetFlags()[9];
    }


    /**
      * Clears the value of the 'doubleField' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearDoubleField() {
      fieldSetFlags()[9] = false;
      return this;
    }

    /**
      * Gets the value of the 'bytesField' field.
      * @return The value.
      */
    public java.nio.ByteBuffer getBytesField() {
      return bytesField;
    }


    /**
      * Sets the value of the 'bytesField' field.
      * @param value The value of 'bytesField'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setBytesField(java.nio.ByteBuffer value) {
      validate(fields()[10], value);
      this.bytesField = value;
      fieldSetFlags()[10] = true;
      return this;
    }

    /**
      * Checks whether the 'bytesField' field has been set.
      * @return True if the 'bytesField' field has been set, false otherwise.
      */
    public boolean hasBytesField() {
      return fieldSetFlags()[10];
    }


    /**
      * Clears the value of the 'bytesField' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearBytesField() {
      bytesField = null;
      fieldSetFlags()[10] = false;
      return this;
    }

    /**
      * Gets the value of the 'decimalField' field.
      * @return The value.
      */
    public java.math.BigDecimal getDecimalField() {
      return decimalField;
    }


    /**
      * Sets the value of the 'decimalField' field.
      * @param value The value of 'decimalField'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setDecimalField(java.math.BigDecimal value) {
      validate(fields()[11], value);
      this.decimalField = value;
      fieldSetFlags()[11] = true;
      return this;
    }

    /**
      * Checks whether the 'decimalField' field has been set.
      * @return True if the 'decimalField' field has been set, false otherwise.
      */
    public boolean hasDecimalField() {
      return fieldSetFlags()[11];
    }


    /**
      * Clears the value of the 'decimalField' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearDecimalField() {
      decimalField = null;
      fieldSetFlags()[11] = false;
      return this;
    }

    /**
      * Gets the value of the 'timestampLogicalField' field.
      * @return The value.
      */
    public java.time.Instant getTimestampLogicalField() {
      return timestampLogicalField;
    }


    /**
      * Sets the value of the 'timestampLogicalField' field.
      * @param value The value of 'timestampLogicalField'.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder setTimestampLogicalField(java.time.Instant value) {
      validate(fields()[12], value);
      this.timestampLogicalField = value.truncatedTo(java.time.temporal.ChronoUnit.MILLIS);
      fieldSetFlags()[12] = true;
      return this;
    }

    /**
      * Checks whether the 'timestampLogicalField' field has been set.
      * @return True if the 'timestampLogicalField' field has been set, false otherwise.
      */
    public boolean hasTimestampLogicalField() {
      return fieldSetFlags()[12];
    }


    /**
      * Clears the value of the 'timestampLogicalField' field.
      * @return This builder.
      */
    public io.asouquieres.avromodel.DemoAvro.Builder clearTimestampLogicalField() {
      fieldSetFlags()[12] = false;
      return this;
    }

    @Override
    @SuppressWarnings("unchecked")
    public DemoAvro build() {
      try {
        DemoAvro record = new DemoAvro();
        record.stringField = fieldSetFlags()[0] ? this.stringField : (java.lang.String) defaultValue(fields()[0]);
        record.optionalStringField = fieldSetFlags()[1] ? this.optionalStringField : (java.lang.String) defaultValue(fields()[1]);
        record.arrayOfObject = fieldSetFlags()[2] ? this.arrayOfObject : (java.util.List<io.asouquieres.avromodel.ChildAvro>) defaultValue(fields()[2]);
        record.mapOfStrings = fieldSetFlags()[3] ? this.mapOfStrings : (java.util.Map<java.lang.String,java.lang.String>) defaultValue(fields()[3]);
        record.mapOfReusedObjects = fieldSetFlags()[4] ? this.mapOfReusedObjects : (java.util.Map<java.lang.String,io.asouquieres.avromodel.ChildAvro>) defaultValue(fields()[4]);
        record.booleanField = fieldSetFlags()[5] ? this.booleanField : (java.lang.Boolean) defaultValue(fields()[5]);
        record.intField = fieldSetFlags()[6] ? this.intField : (java.lang.Integer) defaultValue(fields()[6]);
        record.longField = fieldSetFlags()[7] ? this.longField : (java.lang.Long) defaultValue(fields()[7]);
        record.floatField = fieldSetFlags()[8] ? this.floatField : (java.lang.Float) defaultValue(fields()[8]);
        record.doubleField = fieldSetFlags()[9] ? this.doubleField : (java.lang.Double) defaultValue(fields()[9]);
        record.bytesField = fieldSetFlags()[10] ? this.bytesField : (java.nio.ByteBuffer) defaultValue(fields()[10]);
        record.decimalField = fieldSetFlags()[11] ? this.decimalField : (java.math.BigDecimal) defaultValue(fields()[11]);
        record.timestampLogicalField = fieldSetFlags()[12] ? this.timestampLogicalField : (java.time.Instant) defaultValue(fields()[12]);
        return record;
      } catch (org.apache.avro.AvroMissingFieldException e) {
        throw e;
      } catch (java.lang.Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumWriter<DemoAvro>
    WRITER$ = (org.apache.avro.io.DatumWriter<DemoAvro>)MODEL$.createDatumWriter(SCHEMA$);

  @Override public void writeExternal(java.io.ObjectOutput out)
    throws java.io.IOException {
    WRITER$.write(this, SpecificData.getEncoder(out));
  }

  @SuppressWarnings("unchecked")
  private static final org.apache.avro.io.DatumReader<DemoAvro>
    READER$ = (org.apache.avro.io.DatumReader<DemoAvro>)MODEL$.createDatumReader(SCHEMA$);

  @Override public void readExternal(java.io.ObjectInput in)
    throws java.io.IOException {
    READER$.read(this, SpecificData.getDecoder(in));
  }

}










